#include <exec/types.h>
#include <proto/exec.h>
#include <proto/containerkit.h>
#include "linearray.h"

// -----------------------------


// -----------------------------


LineArray LineArrayNew(VOID)
{
	#define SIZE_LINEPTR 2
	return NewArray(SIZE_LINEPTR);
}

VOID LineArrayAppend(LineArray array, LINEPTR value)
{
	AppendToArray(LINEPTR, array, value);	
}

VOID LineArrayFree(LineArray array, BOOL freeLines)
{
	if( freeLines )
	{
		ArrayForEach(LINEPTR, aLine, array, LineFree(aLine););
	}
	DeleteArray(array);
}

LINEPTR* LineArrayValues(LineArray array)
{
	return ArrayValues(LINEPTR, array);
}


// -----------------------------------------------
// -----------------------------------------------



